﻿using System.Linq;
using System.Linq.Expressions;

namespace LinqToLdap.Tests.TestSupport
{
    public class MockQueryProvider : IQueryProvider
    {
        public Expression ExpressionToExecute { get; private set; }
        public IQueryable CreateQuery(Expression expression)
        {
            return CreateQuery<object>(expression);
        }

        public IQueryable<TElement> CreateQuery<TElement>(Expression expression)
        {
            ExpressionToExecute = expression;
            return new MockQuery<TElement>(this, expression);
        }

        public object Execute(Expression expression)
        {
            ExpressionToExecute = expression;
            return null;
        }

        public TResult Execute<TResult>(Expression expression)
        {
            ExpressionToExecute = expression;
            return default(TResult);
        }
    }
}